<template>
    <div class="container">
        <div class="heading">Map metabolite names to HMDB identifiers</div>
        <div style="align-self: baseline;">Here, you can provide a concentration data file (or simply a list of metabolites) and automatically map them to their <a href="https://hmdb.ca/" target="_blank">Human Metabolome Database (HMDB)</a> accession numbers.</div>
        <div style="margin-bottom: 0.25rem;">We use our own database (which relies on HMDB data) to try and find a suitable accession ID first.<br> In case we don't find database matches, we attempt resolving the metabolite name using
            <a href="https://cts.fiehnlab.ucdavis.edu/" target="_blank">The Chemical Translation Service</a> provided by the Fiehn Lab at UC Davis West Coast Metabolomics Center. We thank the Fiehn Lab for providing 
            this service. Please check out the according publication <a href="https://doi.org/10.1093/bioinformatics/btq476" target="_blank">here</a>.<br>
            In case no HMDB accession identifier can be found for a metabolite, you will still have the option to provide one manually. Otherwise, the original identifier will remain.
        </div>
        <div v-if="studies.hmdb_enforced">This MetaboSERV instance <b>does enforce HMDB identifiers</b>.</div>
        <div v-if="!studies.hmdb_enforced">This MetaboSERV instance does not enforce HMDB identifiers, but you may still use them.</div>
        <div class="mapper">
            <div>Provide a file with concentration data:</div>
            <input type="file" @change="setMetaboliteFile">
            <div class="buttons" style="margin-top: 0.5rem; align-items: center;">
                <button @click="mapFile">Map</button>
                <span>Transpose: <input type="checkbox" v-model="transpose"></span>
                <VueSpinnerGears v-if="loading" size="24" color="var(--color-primary)"></VueSpinnerGears>
            </div>
            <span style="font-size: 0.65rem; color: #7a7a7a;">Please check the "transpose" option if your metabolites are the <b>rows</b> of your file.</span>
        </div>
        <div class="mapper">
            <div>Or enter semicolon-separated metabolites here:</div>
            <input type="text" v-model="metabolites_to_map" placeholder="Alanine;Glucose;2-Hydroxybutyrate">
            <div class="buttons" style="margin-top: 0.5rem;">
                <button @click="mapString">Map</button>
            </div>
            <span style="font-size: 0.65rem; color: #7a7a7a;">If your metabolite name contains a semicolon, please replace it with the phrase <b>SEMICOLON</b>.</span>
        </div>
        <div v-if="results && Object.keys(results!).length > 0" class="mapping-area">
            <div class="map-grid-item bold">
                <div>Input Key</div>
                <div>HMDB Accession</div>
                <div>Source</div>
                <div>According DB Value</div>
                <div>Options</div>
            </div>
            <div v-for="res of Object.keys(results)" class="map-grid-item">
                <div>{{ res.replace("SEMICOLON", ";") }}</div>
                <div v-if="results[res]">{{ results[res]['failed'] ? "-" : results[res]['res'] }}</div>
                <div v-if="results[res] && results[res]['conf']">{{ results[res]['conf'] === 'database-fuzzy' ? "DB Match (fuzzy)" : (results[res]['conf'] === 'database-exact' ?
                     "DB Match (exact)" : (results[res]['conf'] === 'manual' ? "Manual" :"Online (CTS)")) }}</div>
                <div v-if="results[res] && results[res]['conf'] && !results[res]['failed']">{{ results[res]['conf'].startsWith('database') ? results[res]['original'] : res }}</div>
                <div v-if="results[res] && results[res]['failed']">Failed</div>
                <div v-if="results[res] && results[res]['failed']">-</div>
                <div v-if="results[res] && !results[res]['accepted'] && !results[res]['failed']" class="map-buttons">
                    <button title="Previous metabolite" @click="previousDBMetabolite(res, results[res]['res'])"><</button>
                    <button title="Next metabolite" @click="nextDBMetabolite(res, results[res]['res'])">></button>
                    <button title="Add the identifier manually" @click="addManuallyFor(res)">+</button>
                    <button title="Accept this HMDB ID" @click="results[res]['accepted'] = true"><span style="color: var(--color-positive)">✓</span></button>
                    <button title="Don't accept suggestion" @click="acceptFailed(res)"><span style="color: var(--color-negative)">✖</span></button>
                </div>
                <div v-if="results[res] && results[res]['accepted']"><span style="color: var(--color-other)">Accepted</span></div>
                <div v-if="results[res] && results[res]['failed']">
                    <button title="Add the identifier manually" @click="addManuallyFor(res)">+</button>
                    <button title="Keep the metabolite name for now" @click="acceptFailed(res)"><span style="color: var(--color-positive)">✓</span></button>
                </div>
            </div>
        </div>
        <div class="buttons download-area" v-if="results && Object.keys(results!).length > 0">
            <button v-if="!all_accepted" @click="acceptAll">Accept all suggestions</button>
            <button v-if="!all_accepted" @click="acceptAllButFailed">Accept all suggestions (exclude failed)</button>
            <button :disabled="!all_accepted" @click="serveAsJson">Download mapping (JSON)</button>
            <button :disabled="!all_accepted" @click="serveAsCSV">Download mapping(CSV)</button>
            <button :disabled="!all_accepted" @click="serveAdaptedFile" v-if="file_mapped">Download adapted file</button>
            <VueSpinnerGears v-if="download_loading" size="24" color="var(--color-primary)"></VueSpinnerGears>
        </div>
        <div v-if="results && Object.keys(results!).length > 0 && !all_accepted" style="color: var(--color-info)">Please accept or manually add an identifier for each metabolite to continue.</div>
    </div>
</template>

<script setup lang="ts">
import { areHMDBIdentifiersEnforced, deleteTempFile, mapMetaboliteToHMDB, nextMetabolite, previousMetabolite, retrieveMetaboliteNamesFromFile, serveMappedMetabolitesAdaptedFile, serveMappedMetabolitesAsCSV, serveMappedMetabolitesAsJSON } from '@/modules/query_module';
import { useMessageStore, type Message } from '@/stores/message';
import { type ArbitraryObject } from '@/stores/query';
import { computed, onMounted, ref } from 'vue';
import { useStudyStore } from '@/stores/studies';
import { VueSpinnerGears } from 'vue3-spinners';

const studies = useStudyStore();
const msg = useMessageStore();
const transpose = ref<boolean>(false);

const all_accepted = computed((): boolean => {
    if (!results.value || results.value == null) return false;
    return Object.keys(results.value).filter((k) => results.value && results.value[k] && !results.value[k]['accepted']).length == 0;
})

onMounted(async () => {
    if (studies.hmdb_enforced === null) {
        let enforced = await areHMDBIdentifiersEnforced();
        studies.hmdb_enforced = enforced.body as boolean;
    }
})

const setMetaboliteFile = (e: Event) => {
    e?.preventDefault();
    const target = e.target as HTMLInputElement;
    if (target.files) {
        metabolite_file.value = new File([target.files[0]], target.files[0].name);

    }
    else {
        metabolite_file.value = null;
    }
}

const mapString = async () => {
    if (!metabolites_to_map.value) return;
    results.value = {};
    file_mapped.value = false;
    for (let metabolite of metabolites_to_map.value.split(";")) {
        metabolite = metabolite.trim().replace(";","SEMICOLON");
        let res: Message = await mapMetaboliteToHMDB(metabolite);
        if (res.status == 200) {
            let rb: MappedMetabolite = res.body[metabolite];
            results.value[metabolite] = rb;
            results.value[metabolite]["accepted"] = (rb["conf"] === 'database-exact')
        }   
    }
};

const nextDBMetabolite = async (compound: string, hmdb: string) => {
    const met_res: Message = await nextMetabolite(compound, hmdb);
    if (met_res.status == 200 && results.value) {
        results.value[compound] = met_res.body[compound] as MappedMetabolite;
        results.value[compound]["accepted"] = false;
    }
}

const previousDBMetabolite = async (compound: string, hmdb: string) => {
    const met_res: Message = await previousMetabolite(compound, hmdb);
    if (met_res.status == 200 && results.value) {
        results.value[compound] = met_res.body[compound] as MappedMetabolite;
        results.value[compound]["accepted"] = false;
    }
}

interface MappedMetabolite {
    conf: string,
    res: string,
    original?: string,
    failed?: boolean
};

const mapFile = async () => {
    if (!metabolite_file.value) return;
    results.value = {};
    file_mapped.value = true;
    loading.value = true;
    const res: Message = await retrieveMetaboliteNamesFromFile(metabolite_file.value, transpose.value);
    if (res.status === 200) {
        for (let metabolite of res.body) {
            metabolite = metabolite.trim().replace(";","SEMICOLON")
            let res: Message = await mapMetaboliteToHMDB(metabolite.trim());
            if (res.status == 200) {
                let rb: MappedMetabolite = res.body[metabolite];
                results.value[metabolite] = rb;
                results.value[metabolite]["accepted"] = (rb["conf"] === 'database-exact')
            }   
        }
    } else {
        msg.add_message(res);
    }
    loading.value = false;
};

const addManuallyFor = (metabolite: string) => {
    const hmdb_id = prompt("Please enter the according HMDB identifier (HMDBXXXXXXX):");
    if (hmdb_id && results.value)
        if (hmdb_regex.value.test(hmdb_id)) {
            metabolite = metabolite.trim().replace(";","SEMICOLON");
            results.value[metabolite] = {conf: "manual", res: hmdb_id, original: hmdb_id, accepted: true};
        }
        else
            msg.add_message({status: 400, msg: "Please provide a valid HMDB identifier!"});
}

const acceptFailed = (metabolite: string) => {
    if (results.value) {
        delete results.value[metabolite.trim().replace(";","SEMICOLON")];
    }
}

const acceptAll = () => {
    if (!results.value) return;
    Object.keys(results.value).forEach((k) => {
        if (results.value && results.value[k] && results.value[k]["failed"])
            delete results.value![k];
        else
            results.value![k]["accepted"] = true;
    })
}

const acceptAllButFailed = () => {
    if (!results.value) return;
    Object.keys(results.value).forEach((k) => {
        if (results.value![k]["failed"])
            return;
        results.value![k]["accepted"] = true;
    })
}

const serveAsJson = async () => {
    if (!results.value) return;
    const potential_blob = await serveMappedMetabolitesAsJSON(results.value)
    if (potential_blob) {
        const link = document.createElement('a');
        link.href = URL.createObjectURL(potential_blob);
        link.download = "mappedMetabolites.json";
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
        URL.revokeObjectURL(link.href);
    }
}

const serveAsCSV = async () => {
    if (!results.value) return;
    const potential_blob = await serveMappedMetabolitesAsCSV(results.value)
    if (potential_blob) {
        const link = document.createElement('a');
        link.href = URL.createObjectURL(potential_blob);
        link.download = "mappedMetabolites.csv";
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
        URL.revokeObjectURL(link.href);
    }
}

const serveAdaptedFile = async () => {
    if (!results.value || !metabolite_file.value) return;
    download_loading.value = true;
    const potential_blob = await serveMappedMetabolitesAdaptedFile(metabolite_file.value, results.value, transpose.value)
    if (potential_blob) {
        const link = document.createElement('a');
        link.href = URL.createObjectURL(potential_blob);
        const file_split = metabolite_file.value.name.split(".");
        link.download = file_split[0] + "_adapted." + file_split[1]; 
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
        URL.revokeObjectURL(link.href);
    }
    download_loading.value = false;
}

const is_hmdb_enforced = ref<boolean>(false);
const metabolites_to_map = ref<string>();
const metabolite_file = ref<File|null>(null);
const results = ref<ArbitraryObject|null>({});
const file_mapped = ref<boolean>(false);
const hmdb_regex = ref<RegExp>(new RegExp('^HMDB[0-9]{7}$'));
const loading = ref<boolean>(false);
const download_loading = ref<boolean>(false);
</script>

<style scoped>

a, a:active {
    color: var(--color-primary);
}

a:hover {
    color: var(--color-head);
}

.container {
    display: flex;
    max-width: 70%;
    margin: auto;
    align-items: center;
    flex-direction: column;
    font-size: 0.9rem;

}

.heading {
    margin-top: 1rem;
    font-size: var(--fs-title);
    text-align: center;
    color: var(--color-head);
    font-weight: bold;
}

.mapper {
    border: var(--bd-default);
    display: flex;
    flex-direction: column;
    padding: 1rem 3rem;
    margin-top:  1rem;
    min-width: 30rem;
    
}

.mapping-area {
    width: 100%;
    margin-top: 1rem;
    border: var(--bd-default);
    overflow-y: auto;
    min-height: 10rem;
    padding-left: 0.5rem;
}

.map-grid-item {
    display: grid;
    grid-template-columns: repeat(4, 1fr) 0.4fr;
    align-items: baseline;
}

.bold {
    font-weight: 600;
}

.download-area {
    margin-top: 1rem;
    min-height: 1rem;
    border: var(--bd-default);
    width: fit-content;
    padding: 1rem;
}

</style>